
  IMPLEMENTATION MODULE FileInfo;

  (******************************************************************)
  (*                                                                *)
  (*        MODULE: FileInfo,            Version   0.1 / 001        *)
  (*                                                                *)
  (*        Purpose: provide some FileInfo by a Dialog-Box.         *)
  (*                                                                *)
  (*        Implementation:  For Apple Macintosh                    *)
  (*                                                                *)
  (*        Programming:     O. Roth                                *)
  (*                         Institut fr Phytomedizin              *)
  (*                         ETH-Zentrum /CLS                       *)
  (*                         CH-8092 Zrich                         *)
  (*                                                                *)
  (*        LAST MODIFICATION :  27. 9.90                           *)
  (******************************************************************)
  
  FROM DMFiles IMPORT   TextFile, Response, IOMode;
  
  FROM DMAlerts IMPORT  ShowAlert, WriteMessage; 
 
  FROM DMConversions IMPORT IntToString;
 
  FROM DMStrings IMPORT  AssignString, Concatenate;
 
  IMPORT ASCII;



  TYPE
    string = ARRAY[0..255] OF CHAR;



  VAR
    filename : string;
    floc     : TextFile;




  PROCEDURE FileStatus;

  VAR
    message, str : string;

  BEGIN

    WriteMessage( 2, 2, "INFO about TextFile: " );

    Concatenate( "Name:  ", floc.filename, message );
    WriteMessage( 4, 2, message );

    CASE floc.res OF
      done          : str:= "done";
    | filenotfound  : str:= "file not found";
    | volnotfound   : str:= "vol not found";
    | cancelled     : str:= "cancelled";
    | unknownfile   : str:= "unknown file";
    | toomanyfiles  : str:= "too many files";
    | diskfull      : str:= "disk full";
    | memfull       : str:= "mem full";
    | notdone       : str:= "not done";
    END; (* CASE *)
    Concatenate( "Response of fileopening is:  ", str, message );
    WriteMessage( 6, 2, message );
      
    CASE floc.curIOMode OF
      reading  : str:= "reading";
    | writing  : str:= "writing";
    END; (* CASE *)
    Concatenate( "Current IO-Mode is:  ", str, message );
    WriteMessage( 7, 2, message );
    
    str[0]:= floc.curChar; str[1]:= ASCII.nul;
    Concatenate( "Character at current fileposition is:  ", str, message );
    WriteMessage( 8, 2, message );

    IntToString( ORD( floc.curChar ), str, 3 );
    Concatenate( "( = Decimal: ", str, message );
    Concatenate( message, ")", message );
    WriteMessage( 9, 2, message );

  END FileStatus;



  PROCEDURE WriteFileStatus( f: TextFile );
  (* -------------------------------------------------------------- *)
  (*  Writes all the available Information on File-Status in an     *)
  (*  Alert-Box                                                     *)
  (* -------------------------------------------------------------- *)
  

  BEGIN

    floc.res:= f.res;
    AssignString( f.filename, floc.filename );
    floc.curIOMode:= f.curIOMode;
    floc.curChar:= f.curChar;

    ShowAlert( 11, 50, FileStatus );

  END WriteFileStatus;
  

END FileInfo.
