IMPLEMENTATION MODULE Journaling;

  (*

        Implementation and Revisions:
        ============================

        Author  Date        Description
        ------  ----        -----------

        af      18/04/89    First implementation (DM 1.0,
                            MacMETH 2.5.1)
         dg		12/07/91	- DispError replaced by DMMessages.DoInform
        jth		27/01/93    renamed DMJournaling to Journaling

  *)
  FROM DMWindowIO IMPORT SetPos,
    SetWindowFont, WindowFont, FontStyle,
    BackgroundWidth, BackgroundHeight, SelectForOutput;    
  IMPORT DMWindowIO;

  FROM DMFiles IMPORT
     Response, HiddenFileInfo, IOMode, TextFile, GetExistingFile, 
     CreateNewFile, Lookup, Close, Delete, Rename, Reset, Rewrite, 
     EOF, Again, ReadByte, WriteByte, EOL, ReadChar, SkipGap, 
     ReadChars, WriteChar, WriteEOL, WriteChars, legalNum, 
     GetCardinal, PutCardinal, GetInteger, PutInteger, (*. GetReal, .*)
     PutReal, PutRealSci; 

  FROM DMMessages IMPORT DoInform;
  

  VAR
    jf: TextFile; jfOpen: BOOLEAN;

  PROCEDURE OpenJournal;
  BEGIN
    IF NOT jfOpen THEN
      CreateNewFile(jf,"Open as Journal File:","Journal.PROT");
      IF (jf.res<>done) AND (jf.res<>cancelled) THEN 
        DoInform(210,"Journaling","OpenJournal",jf.filename);
      ELSIF (jf.res=done) THEN
        jfOpen:= TRUE;
      END(*IF*);
    ELSE
      DoInform(211,"Journaling","OpenJournal",jf.filename);
    END(*IF*);
  END OpenJournal;
  
  PROCEDURE CloseJournal;
  BEGIN
    IF jfOpen THEN
      Close(jf); jfOpen:= FALSE;
    END(*IF*);
  END CloseJournal;
  
  PROCEDURE Write(ch: CHAR);
  BEGIN
    DMWindowIO.Write(ch); 
    IF jfOpen THEN
      WriteChar(jf,ch);
    END(*IF*);
  END Write;
  
  PROCEDURE WriteString ( s: ARRAY OF CHAR );
  BEGIN
    DMWindowIO.WriteString(s); 
    IF jfOpen THEN
      WriteChars(jf,s);
    END(*IF*);
  END WriteString;
  
  PROCEDURE WriteLn;
  BEGIN
    DMWindowIO.WriteLn; 
    IF jfOpen THEN
      WriteEOL(jf);
    END(*IF*);
  END WriteLn;
  
  PROCEDURE WriteInt ( i,c: INTEGER );
  BEGIN
    DMWindowIO.WriteInt(i,c); 
    IF jfOpen THEN
      PutInteger(jf,i,c);
    END(*IF*);
  END WriteInt;
  
  PROCEDURE WriteReal ( x: REAL; fw,dec: INTEGER );
  BEGIN
    DMWindowIO.WriteReal(x,fw,dec); 
    IF jfOpen THEN
      PutReal( jf,x,fw,dec);
    END(*IF*);
  END WriteReal;
  
  PROCEDURE WriteRealSci ( x: REAL; fw,dec: INTEGER );
  BEGIN
    DMWindowIO.WriteRealSci(x,fw,dec); 
    IF jfOpen THEN
      PutRealSci( jf,x,fw );
    END(*IF*);
  END WriteRealSci;
  
  PROCEDURE EraseContent;
  BEGIN
    DMWindowIO.EraseContent;
    WriteEOL(jf);
    WriteEOL(jf);
    WriteEOL(jf);
    WriteEOL(jf);
    WriteEOL(jf);
  END EraseContent;

BEGIN
  jfOpen:= FALSE;
END Journaling.
