IMPLEMENTATION MODULE SimpleSounds;

  (*

        Implementation and Revisions:
        ============================

        Author  Date        Description
        ------  ----        -----------

        af      01/07/88    First implementation (DM 1.0,
                            MacMETH 2.4)
        af		10/01/92	Fixed to no longer depend on DM

  *)


(*
  CONST
  
    (* four-tone synthesizer *)
    
    C 	= 3025DH;
    Cis = 3302CH;
    D 	= 360B5H;
    Es	= 39420H;
    E	= 3CA99H;
    F	= 40450H;
    Ges	= 44176H;
    G	= 4823EH;
    Gis	= 4C6E1H;
    A	= 50F98H;
    B	= 55CA2H;
    H	= 5AE41H;
*)

  FROM SYSTEM IMPORT BYTE, REG, SETREG, INLINE, SHORT, VAL, ADDRESS;
  
  FROM SoundDriver IMPORT
    Ptr, ProcPtr, Byte, Fixed, 
    swMode, 
    Tone, Tones, SWSynthRec, SWSynthPtr,
    ftMode, 
    FTSynthPtr, FTSndRecPtr, WavePtr, FTSynthRec, FTSoundRec, Wave,
    StartSound, StopSound, SoundDone, GetSoundVol,
    SetSoundVol;



  CONST
	A0 = 8;
	D0 = 0;

  TYPE
    Handle       = POINTER TO Ptr;          (* pointer to a master pointer  *)
    Size 		 = LONGINT;


  PROCEDURE NewHandle(byteCount: Size): Handle;
  BEGIN
	SETREG(D0,byteCount);
	INLINE(0A122H);
	RETURN VAL(Handle,REG(A0))
  END NewHandle;

  PROCEDURE DisposHandle(VAR h: Handle);
  BEGIN
    SETREG(A0,h);
    INLINE(0A023H);
  END DisposHandle;

  PROCEDURE HLock(h: Handle);
  BEGIN
	SETREG(A0,h);
	INLINE(0A029H);
  END HLock;

  PROCEDURE HUnLock(h: Handle);
  BEGIN
	SETREG(A0,h);
	INLINE(0A02AH);
  END HUnLock;



  PROCEDURE Sound(f: INTEGER; d: INTEGER); 
    CONST buffSize = 14;
    VAR myHandle: Handle; myPtr: Ptr; mySWPtr: SWSynthPtr;
  BEGIN
    myHandle:= NewHandle(buffSize);
    HLock(myHandle); myPtr:= myHandle^;
    mySWPtr:= VAL(SWSynthPtr,myPtr);
    WITH mySWPtr^ DO
      mode:= swMode;
      triplets[0].count:= f;
      triplets[0].amplitude:= 255;
      triplets[0].duration:= d;
      triplets[1].count:= 0;
      triplets[1].amplitude:= 0;
      triplets[1].duration:= 0;
    END(*WITH*);
    StartSound(myPtr,buffSize,VAL(ADDRESS,-1D));
    HUnLock(myHandle);
    DisposHandle(myHandle);
  END Sound;


END SimpleSounds.
