IMPLEMENTATION MODULE SoundDriver;
(* C. Pfister 23-Jan-86/ 28/6/88 af
   - SetSoundVol not implemented *)

  (* FROM OSUtilities IMPORT GetByte; *)
  (* FROM PBManager IMPORT PBWrite; *)
  (* FROM PBTypes   IMPORT ParamBlockRec; *)
  (* FROM MacTypes  IMPORT Ptr, ProcPtr; *)
  FROM SYSTEM    IMPORT VAL, ADR, ADDRESS, INLINE, SETREG;

  (* FROM MacTypes IMPORT
    Byte, ProcPtr, Handle, Ptr, Point, OSErr, StringPtr, WindowPtr, 
    FInfo, FXInfo, DInfo, DXInfo, SerShk, SerStaRec; *)


  CONST
    A0     = 8;
    D0     = 0;
    sync   = 0A000H;
    async  = 0A400H;
    hfsBit = 200H;
    hsync  = 0A260H;
    hasync = 0A660H;


  TYPE
    Handle       = POINTER TO Ptr;

    ProcHandle   = POINTER TO ProcPtr;

    Fract        = LONGINT;

     (* QuickDraw *)

    Str255       = ARRAY [0..255] OF CHAR;
    StringPtr    = POINTER TO Str255;
    StringHandle = POINTER TO StringPtr;
    VHSelect     = (v, h);
    VHSelectR    = [v..h];
    Point =
        RECORD
          CASE :INTEGER OF
            0: v: INTEGER;
               h: INTEGER
          | 1: vh: ARRAY VHSelectR OF INTEGER
          END
        END;
        
        
  (* QuickDraw *)

    StyleItem = (bold, italic, underline, outline, shadow, condense, extend);
    Style     = SET OF StyleItem;

    Rect =
        RECORD
          CASE :INTEGER OF
            0: top:      INTEGER;
               left:     INTEGER;
               bottom:   INTEGER;
               right:    INTEGER
          | 1: topLeft:  Point;
               botRight: Point
          END
        END;

    RgnHandle = POINTER TO RgnPtr;
    RgnPtr    = POINTER TO Region;
    Region    =
        RECORD
          rgnSize: INTEGER;  (* rgnSize = 10 for rectangular *)
          rgnBBox: Rect;
          (* plus more data if not rectangular *)
        END;

    BitMap =
        RECORD
          baseAddr: Ptr;
          rowBytes: INTEGER;
          bounds:   Rect
        END;

    PatPtr    = POINTER TO Pattern;
    PatHandle = POINTER TO PatPtr;
    Pattern   = ARRAY [0..7] OF Byte;                (* change *)

    Bits16    = ARRAY [0..15] OF BITSET;             (* change *)

    CursPtr    = POINTER TO Cursor;
    CursHandle = POINTER TO CursPtr;
    Cursor     =
        RECORD
          data:    Bits16;
          mask:    Bits16;
          hotSpot: Point
        END;

    QDProcsPtr = POINTER TO QDProcs;
    QDProcs =
        RECORD
          textProc:    Ptr;
          lineProc:    Ptr;
          rectProc:    Ptr;
          rRectProc:   Ptr;
          ovalProc:    Ptr;
          arcProc:     Ptr;
          polyProc:    Ptr;  (* error in IM pascal data structures *) (* change *)
          rgnProc:     Ptr;
          bitsProc:    Ptr;
          commentProc: Ptr;
          txMeasProc:  Ptr;
          getPicProc:  Ptr;
          putPicProc:  Ptr
        END;

    GrafPtr  = POINTER TO GrafPort;
    GrafPort =
        RECORD
          device:      INTEGER;
          portBits:    BitMap;
          portRect:    Rect;
          visRgn:      RgnHandle;
          clipRgn:     RgnHandle;
          bkPat:       Pattern;
          fillPat:     Pattern;
          pnLoc:       Point;
          pnSize:      Point;
          pnMode:      INTEGER;
          pnPat:       Pattern;
          pnVis:       INTEGER;
          txFont:      INTEGER;
          txFace:      Style;
          txMode:      INTEGER;
          txSize:      INTEGER;
          spExtra:     LONGINT;
          fgColor:     LONGINT;
          bkColor:     LONGINT;
          colrBit:     INTEGER;
          patStretch:  INTEGER;
          picSave:     Handle;
          rgnSave:     Handle;
          polySave:    Handle;
          grafProcs:   QDProcsPtr
        END;



     (* OSUtilities *)

    OSErr    = INTEGER;
    OSType   = ARRAY [1..4] OF CHAR;
    TrapType = (OSTrap, ToolTrap);


     (* some general types *)

    QElemPtr = POINTER TO QElem;
    QHdrPtr  = POINTER TO QHdr;
    QHdr =
        RECORD
          qFlags: BITSET;
          qHead:  QElemPtr;
          qTail:  QElemPtr
        END;


     (* OSEventManager *)

    EvQEl =
        RECORD
          qLink:         QElemPtr;
          qType:         INTEGER;
          evtQWhat:      INTEGER;
          evtQMessage:   LONGINT;
          evtQWhen:      LONGINT;
          evtQWhere:     Point;
          evtQModifiers: BITSET
        END;


   (* FileManager *)

    FInfo =
        RECORD
          fdType:     OSType;
          fdCreator:  OSType;
          fdFlags:    BITSET;
          fdLocation: Point;
          fdFldr:     INTEGER
        END;

    FXInfo =
        RECORD
          fdIconID:  INTEGER;
          fdUnused:  ARRAY [1..4] OF INTEGER;
          fdComment: INTEGER;
          fdPutAway: LONGINT
        END;

    DInfo =
        RECORD
          frRect:     Rect;
          frFlags:    BITSET;
          frLocation: Point;
          frView:     INTEGER
        END;

    DXInfo =
        RECORD
          frScroll:    Point;
          frOpenChain: LONGINT;
          frUnused:    INTEGER;
          frComment:   INTEGER;
          frPutAway:   LONGINT;
        END;
        

  (* WindowManager *)

    WindowPtr    = GrafPtr;


  (* FileManager *)

    ParamBlkType  = (ioParam, fileParam, volumeParam, cntrlParam);
    ParmBlkPtr    = POINTER TO ParamBlockRec;
    ParamBlockRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          CASE :ParamBlkType OF
            ioParam:
              ioRefNum:    INTEGER;
              ioVersNum:   Byte;                    (* change *)
              ioPermssn:   Byte;                    (* change *)
              ioMisc:      Ptr;
              ioBuffer:    Ptr;
              ioReqCount:  LONGINT;
              ioActCount:  LONGINT;
              ioPosMode:   INTEGER;
              ioPosOffset: LONGINT;
          | fileParam:
              ioFRefNum:    INTEGER;
              ioFVersNum:   Byte;                    (* change *)
              filler1:      Byte;                    (* change *)
              ioFDirIndex:  INTEGER;
              ioFlAttrib:   Byte;                    (* change *)
              ioFlVersNum:  Byte;                    (* change *)
              ioFlFndrInfo: FInfo;
              ioFlNum:      LONGINT;
              ioFlStBlk:    INTEGER;
              ioFlLgLen:    LONGINT;
              ioFlPyLen:    LONGINT;
              ioFlRStBlk:   INTEGER;
              ioFlRLgLen:   LONGINT;
              ioFlRPyLen:   LONGINT;
              ioFlCrDat:    LONGINT;
              ioFlMdDat:    LONGINT;
          | volumeParam:
              filler2:     LONGINT;
              ioVolIndex:  INTEGER;
              ioVCrDate:   LONGINT;
              ioVLsBkUp:   LONGINT;
              ioVAtrb:     BITSET;
              ioVNmFls:    INTEGER;
              ioVDirSt:    INTEGER;
              ioVBlLn:     INTEGER;
              ioVNmAlBlks: INTEGER;
              ioVAlBlkSiz: LONGINT;
              ioVClpSiz:   LONGINT;
              ioAlBlSt:    INTEGER;
              ioVNxtFNum:  LONGINT;
              ioVFrBlk:    INTEGER;
          | cntrlParam:
              ioCRefNum: INTEGER;
              csCode:    INTEGER;
              csParam:   ARRAY [0..10] OF INTEGER
        END
      END;


    HParmBlkPtr = POINTER TO HParamBlockRec;
    HParamBlockRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;  
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          CASE :ParamBlkType OF
            ioParam:
              ioRefNum:    INTEGER;
              ioVersNum:   Byte;                    (* change *)
              ioPermssn:   Byte;                    (* change *)
              ioMisc:      Ptr;
              ioBuffer:    Ptr;
              ioReqCount:  LONGINT;
              ioActCount:  LONGINT;
              ioPosMode:   INTEGER;
              ioPosOffset: LONGINT;
          | fileParam:
              ioFRefNum:    INTEGER;
              ioFVersNum:   Byte;                    (* change *)
              filler1:      Byte;                    (* change *)
              ioFDirIndex:  INTEGER;
              ioFlAttrib:   Byte;                    (* change *)
              ioFlVersNum:  Byte;                    (* change *)
              ioFlFndrInfo: FInfo;
              ioDirID:      LONGINT;
              ioFlStBlk:    INTEGER;
              ioFlLgLen:    LONGINT;
              ioFlPyLen:    LONGINT;
              ioFlRStBlk:   INTEGER;
              ioFlRLgLen:   LONGINT;
              ioFlRPyLen:   LONGINT;
              ioFlCrDat:    LONGINT;
              ioFlMdDat:    LONGINT;
          | volumeParam:
              filler2:     LONGINT;
              ioVolIndex:  INTEGER;
              ioVCrDate:   LONGINT;
              ioVLsMod:    LONGINT;
              ioVAtrb:     BITSET;
              ioVNmFls:    INTEGER;
              ioVBitMap:   INTEGER;
              ioAllocPtr:  INTEGER;
              ioVNmAlBlks: INTEGER;
              ioVAlBlkSiz: LONGINT;
              ioVClpSiz:   LONGINT;
              ioAlBlSt:    INTEGER;
              ioVNxtCNID:  LONGINT;
              ioVFrBlk:    INTEGER;
              ioVSigWord:  INTEGER;
              ioVDrvInfo:  INTEGER;
              ioVDRefNum:  INTEGER;
              ioVFSID:     INTEGER;
              ioVBkUp:     LONGINT;
              ioVSeqNum:   INTEGER;
              ioVWrCnt:    LONGINT;
              ioVFilCnt:   LONGINT;
              ioVDirCnt:   LONGINT;
              ioVFndrInfo: ARRAY [1..8] OF LONGINT
        END
      END;

    CInfoType  = (hFileInfo, dirInfo);
    CInfoPBPtr = POINTER TO CInfoPBRec;
    CInfoPBRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;  
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          ioFRefNum:    INTEGER;
          filler1:      INTEGER;
          ioFDirIndex:  INTEGER;
          ioFlAttrib:   Byte;                    (* change *)
          filler2:      Byte;                    (* change *)
          CASE :CInfoType OF
            hFileInfo:
              ioFlFndrInfo:  FInfo;
              ioDirID:       LONGINT;
              ioFlStBlk:     INTEGER;
              ioFlLgLen:     LONGINT;
              ioFlPyLen:     LONGINT;
              ioFlRStBlk:    INTEGER;
              ioFlRLgLen:    LONGINT;
              ioFlRPyLen:    LONGINT;
              ioFlCrDat:     LONGINT;
              ioFlMdDat:     LONGINT;
              ioFlBkDat:     LONGINT;
              ioFlXFndrInfo: FXInfo;
              ioFlParID:     LONGINT;
              ioFlClpSiz:    LONGINT;
          | dirInfo:
              ioDrUsrWds:   DInfo;
              ioDrDirID:    LONGINT;
              ioDrNmFls:    INTEGER;
              filler3:      ARRAY [1..9] OF INTEGER;
              ioDrCrDat:    LONGINT;
              ioDrMdDat:    LONGINT;
              ioDrBkDat:    LONGINT;
              ioDrFndrInfo: DXInfo;
              ioDrParID:    LONGINT;
            END
          END;

    CMovePBPtr = POINTER TO CMovePBRec;
    CMovePBRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;  
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          filler1:      LONGINT;
          ioNewName:    StringPtr;
          filler2:      LONGINT;
          ioNewDirID:   LONGINT;
          filler3:      ARRAY [1..2] OF LONGINT;
          ioDirID:      LONGINT
        END;

    WDPBPtr = POINTER TO WDPBRec;
    WDPBRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;  
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          filler1:      INTEGER;
          ioWDIndex:    INTEGER;
          ioWDProcID:   LONGINT;
          ioWDVRefNum:  INTEGER;
          filler2:      ARRAY [1..7] OF INTEGER;
          ioWDDirID:    LONGINT
        END;

    FCBPBPtr = POINTER TO FCBPBRec;
    FCBPBRec =
        RECORD
          qLink:        QElemPtr;
          qType:        INTEGER;
          ioTrap:       INTEGER;
          ioCmdAddr:    Ptr;
          ioCompletion: ProcPtr;  
          ioResult:     OSErr;
          ioNamePtr:    StringPtr;
          ioVRefNum:    INTEGER;
          ioRefNum:     INTEGER;
          filler:       INTEGER;
          ioFCBIndx:    LONGINT;
          ioFCBFlNm:    LONGINT;
          ioFCBFlags:   BITSET;
          ioFCBStBlk:   INTEGER;
          ioFCBEOF:     LONGINT;
          ioFCBPLen:    LONGINT;
          ioFCBCrPs:    LONGINT;
          ioFCBVRefNum: INTEGER;
          ioFCBClpSiz:  LONGINT;
          ioFCBParID:   LONGINT
        END;


    VCB = 
        RECORD
          qLink:              QElemPtr;
          qType:              INTEGER;
          vcbFlags:           BITSET;
          vcbSigWord:         INTEGER;
          vcbCrDate:          LONGINT;
          vcbLsMod:           LONGINT;                (* vcbLsBkUp  in   old ROMs *)
          vcbAtrb:            BITSET;
          vcbNmFls:           INTEGER;
          vcbVBMSt:           INTEGER;                (* vcbDirSt   in   old ROMs *)
          vcbAllocPtr:        INTEGER;                (* vcbBlLn    in   old ROMs *)
          vcbNmAlBlks:        INTEGER;                (* vcbNmBlks  in   old ROMs *)
          vcbAlBlkSiz:        LONGINT;
          vcbClpSiz:          LONGINT;
          vcbAlBlSt:          INTEGER;
          vcbNxtCNID:         LONGINT;                (* vcbNxtFNum in   old ROMs *)
          vcbFreeBks:         INTEGER;
          vcbVN:              ARRAY [0..27] OF CHAR;
          vcbDrvNum:          INTEGER;
          vcbDRefNum:         INTEGER;
          vcbFSID:            INTEGER;
          vcbVRefNum:         INTEGER;
          vcbMAdr:            Ptr;
          vcbBufAdr:          Ptr;
          vcbMLen:            INTEGER;
          vcbDirIndex:        INTEGER;
          vcbDirBlk:          INTEGER;
           (* new fields in 128K ROMs: *)
          vcbVolBkUp:         LONGINT;
          vcbVSeqNum:         INTEGER;
          vcbWrCnt:           LONGINT;
          vcbXTClpSiz:        LONGINT;
          vcbCTClpSiz:        LONGINT;
          vcbNmRtDirs:        LONGINT;
          vcbFilCnt:          LONGINT;
          vcbDirCnt:          LONGINT;
          vcbFndrInfo:        ARRAY [1..8] OF LONGINT;
          vcbVCSize:          INTEGER;
          vcbVBMCSiz:         INTEGER;
          vcbCtlCSiz:         INTEGER;
          vcbXTAlBlks:        INTEGER;
          vcbCTAlBlks:        INTEGER;
          vcbXTRef:           INTEGER;
          vcbCTRef:           INTEGER;
          vcbCtlBuf:          LONGINT;
          vcbDirIDM:          LONGINT;
          vcbOffsM:           INTEGER
        END;


    DrvQElPtr = POINTER TO DrvQEl;
    DrvQEl =
        RECORD
          qLink:     QElemPtr;
          qType:     INTEGER;
          dQDrive:   INTEGER;
          dQRefNum:  INTEGER;
          dQFSID:    INTEGER;
          dQDrvSize: INTEGER;
          CASE :INTEGER OF
            0:
              dQDrvSz2: INTEGER
          | 1:
              dQElLth:  INTEGER
          | 2:
              dQElLth2: INTEGER
          END
        END;


     (* DeviceManager *)

    DCtlHandle = POINTER TO DCtlPtr;
    DCtlPtr    = POINTER TO DCtlEntry;
    DCtlEntry = 
        RECORD
          dCtlDriver:   Ptr;
          dCtlFlags:    BITSET;
          dCtlQHdr:     QHdr;
          dCtlPosition: LONGINT;
          dCtlStorage:  Handle;
          dCtlRefNum:   INTEGER;
          dCtlCurTicks: LONGINT;
          dCtlWindow:   WindowPtr;
          dCtlDelay:    INTEGER;
          dCtlEMask:    BITSET;
          dCtlMenu:     INTEGER
        END;


     (* DiskDriver *)

    DrvSts =
        RECORD
          track:       INTEGER;
          writeProt:   Byte;                    (* change *)
          diskInPlace: Byte;                    (* change *)
          installed:   Byte;                    (* change *)
          sides:       Byte;                    (* change *)
          qLink:       QElemPtr;
          qType:       INTEGER;
          dQDrive:     INTEGER;
          dQRefNum:    INTEGER;
          dQFSID:      INTEGER;
          twoSideFmt:  Byte;                    (* change *)
          needsFlush:  Byte;                    (* change *)
          diskErrs:    INTEGER;
        END;


     (* OSUtilities *)

    VBLTask =
        RECORD
          qLink:    QElemPtr;
          qType:    INTEGER;
          vblAddr:  ProcPtr;
          vblCount: INTEGER;
          vblPhase: INTEGER
        END;

    QTypes = (dummyType, vType, ioQType, drvQType, evType, fsQType);

    QElem =
        RECORD
          CASE :QTypes OF
            vType:    vblQelem: VBLTask;         (* vertical blanking      *)
          | ioQType:  ioQElem:  ParamBlockRec;   (* I/O parameter block    *)
          | drvQType: drvQElem: DrvQEl;          (* drive                  *)
          | evType:   evQElem:  EvQEl;           (* event                  *)
          | fsQType:  vcbQElem: VCB;             (* volume control block   *)
          END
        END;




 
  PROCEDURE PBWrite   (paramBlock: ParmBlkPtr; aSync: BOOLEAN): OSErr;
  BEGIN 
    SETREG(A0,paramBlock);
    IF aSync THEN INLINE(async+3H) ELSE INLINE(sync+3H) END;
    RETURN paramBlock^.ioResult
  END PBWrite;


  PROCEDURE GetByte(adr: ADDRESS): CHAR;
  VAR p: POINTER TO CHAR;
  BEGIN
    p := adr;
    RETURN p^
  END GetByte;


  PROCEDURE StartSound(synthRec:      Ptr;
                       numBytes:      LONGINT;
                       completionRtn: ProcPtr);                      
  VAR block: ParamBlockRec; error: INTEGER;
  BEGIN
    WITH block DO
      ioCompletion := completionRtn;
      ioRefNum     := -4;
      ioBuffer     := synthRec;
      ioReqCount   := numBytes;
      IF completionRtn = VAL(ProcPtr,-1D) THEN
        error := PBWrite(ADR(block),FALSE)
      ELSE
        error := PBWrite(ADR(block),TRUE)
      END (* IF *)
    END (* WITH *)
  END StartSound;

  PROCEDURE StopSound; BEGIN END StopSound;

  PROCEDURE SoundDone(): BOOLEAN; BEGIN END SoundDone;

  PROCEDURE GetSoundVol(VAR level: INTEGER);
  VAR b: BITSET;
  BEGIN
    b     := VAL(BITSET,GetByte(260H));
    b     := b * {0..2};
    level := VAL(INTEGER,b)
  END GetSoundVol;

  PROCEDURE SetSoundVol(level: INTEGER);
  BEGIN HALT
  END SetSoundVol;


END SoundDriver.
